using Hcs.ClientNet.Internal;
using Hcs.Service.Async.OrgRegistryCommon;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;

namespace Hcs.ClientNet.Api.Request.OrgRegistryCommon
{
    internal class ExportDataProviderRequest(ClientBase client) : OrgRegistryCommonRequestBase(client)
    {
        internal async Task<IEnumerable<exportDataProviderResultType>> ExecuteAsync(bool isActual, CancellationToken token)
        {
            // http://open-gkh.ru/OrganizationsRegistryCommon/exportDataProviderRequest.html
            var request = new exportDataProviderRequest
            {
                Id = Constants.SIGNED_XML_ELEMENT_ID,
                version = "10.0.2.1"
            };

            if (isActual)
            {
                request.IsActual = true;
                request.IsActualSpecified = true;
            }

            var result = await SendAndWaitResultAsync(request, async asyncClient =>
            {
                var response = await asyncClient.exportDataProviderAsync(CreateRequestHeader(), request);
                return response.AckRequest.Ack;
            }, token);

            return result.Items.OfType<exportDataProviderResultType>();
        }
    }
}
